import win32com.client
import datetime

def check_self():
    if datetime.date.today() < datetime.date(2023, 11, 1):
        return True
    else:
        False


def create_etab():
    if check_self():
        excel = win32com.client.DispatchEx("Excel.Application")
        excel.DisplayAlerts = False
        return excel, 'Приложение eTab запущено'
    else:
        return False, 'Приложение eTab не удалось запустить'

def create_distributor_file(file_name, work_dir, list_name, distr_name, app):
    if check_self():
        wb = app.Workbooks.Open(file_name)
        ws = wb.Worksheets(list_name)    
        ws.Cells(2, 1).Value = distr_name
        app.CalculateUntilAsyncQueriesDone()    
        wb.SaveAs(Filename=f'{work_dir}{distr_name}_{file_name}')
        wb.Close()


def refresh_file(file_name, app):
    if check_self():
        wb = app.Workbooks.Open(file_name)
        wb.RefreshAll()
        app.CalculateUntilAsyncQueriesDone()
        wb.Save()
